Python
import os
from gcore import Gcore
client = Gcore(
api_key=os.environ.get("GCORE_API_KEY"), # This is the default and can be omitted
)
waap_firewall_rule = client.waap.domains.firewall_rules.create(
domain_id=1,
action={},
conditions=[{}],
enabled=True,
name="Block foobar bot",
)
print(waap_firewall_rule.id)package main
import (
"context"
"fmt"
"github.com/G-Core/gcore-go"
"github.com/G-Core/gcore-go/option"
"github.com/G-Core/gcore-go/waap"
)
func main() {
client := gcore.NewClient(
option.WithAPIKey("My API Key"),
)
waapFirewallRule, err := client.Waap.Domains.FirewallRules.New(
context.TODO(),
1,
waap.DomainFirewallRuleNewParams{
Action: waap.DomainFirewallRuleNewParamsAction{},
Conditions: []waap.DomainFirewallRuleNewParamsCondition{{}},
Enabled: true,
Name: "Block foobar bot",
},
)
if err != nil {
panic(err.Error())
}
fmt.Printf("%+v\n", waapFirewallRule.ID)
}
curl --request POST \
--url https://api.gcore.com/waap/v1/domains/{domain_id}/firewall-rules \
--header 'Authorization: <api-key>' \
--header 'Content-Type: application/json' \
--data '
{
"name": "Block foobar bot",
"enabled": true,
"action": {
"allow": {},
"block": {
"action_duration": "12h"
}
},
"conditions": [
{}
],
"description": "<string>"
}
'const options = {
method: 'POST',
headers: {Authorization: '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
name: 'Block foobar bot',
enabled: true,
action: {allow: {}, block: {action_duration: '12h'}},
conditions: [{}],
description: '<string>'
})
};
fetch('https://api.gcore.com/waap/v1/domains/{domain_id}/firewall-rules', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"name": "Block foobar bot",
"enabled": true,
"action": {
"allow": {},
"block": {
"action_duration": "12h"
}
},
"conditions": [
{
"ip": {
"ip_address": "<string>",
"negation": false
},
"ip_range": {
"lower_bound": "<string>",
"upper_bound": "<string>",
"negation": false
}
}
],
"id": 123,
"description": "<string>"
}{
"type": "http-bad-request",
"title": "Bad Request",
"status": 400,
"detail": "Invalid domain name: ''''"
}{
"detail": "Auth token is missing or invalid"
}{
"title": "Quota limit exceeded",
"type": "quota-check-limit-exceeded",
"status": 403,
"detail": "You have reached the maximum limit allowed for your current plan. Please upgrade your plan to add more."
}{
"title": "Resource not found",
"type": "quota-check-no-resource",
"status": 404,
"detail": "The quota resource requested does not exist. Cannot enable WAAP for this domain. Please reach out to our support team."
}{
"type": "request-validation-failed",
"title": "Request validation error.",
"status": 422,
"detail": "One or more fields have validation errors.",
"errors": [
{
"loc": [
"body",
"name"
],
"detail": "Input should be a valid string"
},
{
"loc": [
"body",
"date"
],
"detail": "Field required"
},
{
"loc": [
"query",
"limit"
],
"detail": "Field required"
}
]
}{
"type": "internal-server-error",
"title": "Internal server error.",
"status": 500,
"detail": "An unexpected condition was encountered which prevented the server from fulfilling the request."
}Firewall Rules
Create a firewall rule
POST
/
waap
/
v1
/
domains
/
{domain_id}
/
firewall-rules
Python
import os
from gcore import Gcore
client = Gcore(
api_key=os.environ.get("GCORE_API_KEY"), # This is the default and can be omitted
)
waap_firewall_rule = client.waap.domains.firewall_rules.create(
domain_id=1,
action={},
conditions=[{}],
enabled=True,
name="Block foobar bot",
)
print(waap_firewall_rule.id)package main
import (
"context"
"fmt"
"github.com/G-Core/gcore-go"
"github.com/G-Core/gcore-go/option"
"github.com/G-Core/gcore-go/waap"
)
func main() {
client := gcore.NewClient(
option.WithAPIKey("My API Key"),
)
waapFirewallRule, err := client.Waap.Domains.FirewallRules.New(
context.TODO(),
1,
waap.DomainFirewallRuleNewParams{
Action: waap.DomainFirewallRuleNewParamsAction{},
Conditions: []waap.DomainFirewallRuleNewParamsCondition{{}},
Enabled: true,
Name: "Block foobar bot",
},
)
if err != nil {
panic(err.Error())
}
fmt.Printf("%+v\n", waapFirewallRule.ID)
}
Authorizations
API key for authentication. Make sure to include the word apikey, followed by a single space and then your token.
Example: apikey 1234_abcdef
Path Parameters
The domain ID
Body
application/json
The name assigned to the rule
Required string length:
1 - 100Pattern:
^[A-Za-z0-9\s.:'";<>?&|\\]+$Example:
"Block foobar bot"
Whether or not the rule is enabled
The action that the rule takes when triggered
Show child attributes
Show child attributes
The condition required for the WAAP engine to trigger the rule.
Required array length:
1 elementShow child attributes
Show child attributes
The description assigned to the rule
Maximum string length:
100Response
Successful Response
The name assigned to the rule
Required string length:
1 - 100Pattern:
^[A-Za-z0-9\s.:'";<>?&|\\]+$Example:
"Block foobar bot"
Whether or not the rule is enabled
The action that the rule takes when triggered
Show child attributes
Show child attributes
The condition required for the WAAP engine to trigger the rule.
Required array length:
1 elementShow child attributes
Show child attributes
The unique identifier of the rule
The description assigned to the rule
Maximum string length:
100⌘I